/*----------------------------------------------------------------------------*/
/*
  This file is generated by code_saturne, a general-purpose CFD tool.
*/
/*----------------------------------------------------------------------------*/

#include "cs_defs.h"

/*----------------------------------------------------------------------------
 * Standard C library headers
 *----------------------------------------------------------------------------*/

#include <assert.h>
#include <math.h>

#if defined(HAVE_MPI)
#include <mpi.h>
#endif

/*----------------------------------------------------------------------------
 *  Local headers
 *----------------------------------------------------------------------------*/

#include "cs_headers.h"

/*----------------------------------------------------------------------------*/

BEGIN_C_DECLS

/*----------------------------------------------------------------------------*/

cs_real_t *
cs_meg_boundary_function(const char       *zone_name,
                         const cs_lnum_t   n_elts,
                         const cs_lnum_t  *elt_ids,
                         const cs_real_t   xyz[][3],
                         const char       *field_name,
                         const char       *condition)
{
  cs_real_t *new_vals = NULL;

  /* User defined formula for "temperature" over BC=Bord
    ---------------------------------------------------- */

  if (strcmp(field_name, "temperature") == 0 &&
      strcmp(condition, "dirichlet_formula") == 0 &&
      strcmp(zone_name, "Bord") == 0) {

    const cs_lnum_t vals_size = n_elts * 1;
    BFT_MALLOC(new_vals, vals_size, cs_real_t);

    const cs_real_t Temperature_amb = cs_notebook_parameter_value_by_name("Temperature_amb");

    for (cs_lnum_t e_id = 0; e_id < n_elts; e_id++) {
      cs_lnum_t b_e_id = elt_ids[e_id];
      new_vals[0 * n_elts + e_id] = Temperature_amb;
    }
  }
  return new_vals;
}

/*----------------------------------------------------------------------------*/

END_C_DECLS

